{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,655360}

program Convert_Hlf_to_Htm;
{ணࠬ  䠩  FAR   ⥪⮢ 䠩 (HTM).
    ᯥ⪨  ਭ  ᮧ 㡫樨  ୥}

const
   Ver = 'Version 1.0 (25.10.02)';
   CtrlColorChar : char = #0;
   ColorStr : string[16] = '0123456789ABCDEF';

type
  tBuf = array [1..65528] of char;        {   ᪮७  䠩 }
  tArr = array [1..16, 1..16] of boolean; { ᨢ  ࠭ ᯮ-  }
                                          {  ⠭ 梥⮢            }

var
  f1, f2    : text;
  Buf       : ^tBuf;
  ColorArr  : array [1..16, 1..16] of boolean;

{楤 뢮 ᪠  ࠢ쭮  ࠬ஢}
procedure ShowHelp;
begin
  Writeln;
  Writeln ('  hlf to html                                     ',Ver);
  Writeln ('  ----------------------------------------------------------------------  ');
  Writeln ('  ணࠬ ।祭  ஢ 䠩  FAR`a        ');
  Writeln ('⥪⮢ 㬥.   ᯥ⪨  ਭ  ᮧ ');
  Writeln ('㡫樨  ୥.                                                    ');
  Writeln;
  Writeln ('  ᯮ짮:                                                          ');
  Writeln ('  hlftohtm[.exe] <hlf-file>[.hlf] [<htm-file>]                            ');
  Writeln;
  Writeln ('  :                                                                    ');
  Writeln ('  <hlf-file> -  䠩  FAR;                                      ');
  Writeln ('  <htm-file> -  䠩  ;                                      ');
  Writeln;
  Writeln ('  ਬ:                                                                 ');
  Writeln ('  hlftohtm FarRus.hlf FarRus.htm                                          ');
  Writeln;
  Writeln ('  ணࠬ ࠭ ᢮,   室묨 ⥪⠬.       ');
  Writeln ('  : 㪮  (zhevg@mail.ru)                                    ');
  Writeln;
  Writeln ('  ᫥ 㯭     :                       ');
  Writeln ('  http://plugring.farmanager.com                                          ');
end;


{ 㭪  ਡ 梥  FAR'  ଠ HTML }
function ConvertColor (C : char) : string;
begin
case C of
  '0' : ConvertColor := '#000000';
  '1' : ConvertColor := '#000099';
  '2' : ConvertColor := '#009900';
  '3' : ConvertColor := '#009999';
  '4' : ConvertColor := '#990000';
  '5' : ConvertColor := '#990099';
  '6' : ConvertColor := '#666600';
  '7' : ConvertColor := '#CCCCCC';
  '8' : ConvertColor := '#999999';
  '9' : ConvertColor := '#0000FF';
  'A' : ConvertColor := '#00FF00';
  'B' : ConvertColor := '#00FFFF';
  'C' : ConvertColor := '#FF0000';
  'D' : ConvertColor := '#FF00FF';
  'E' : ConvertColor := '#FFFF00';
  'F' : ConvertColor := '#FFFFFF';
  else
    ConvertColor := '#000000';
end;
end;


{  htm-䠩; ᠭ ⨫}
procedure WriteTop;
var
  i,j : byte;
  First : boolean;
begin
  Writeln (f2, '<HTML>');
  Writeln (f2, '<HEAD>');
  Writeln (f2, '<meta http-equiv=Content-Type content=text/html; charset=cp866>');
  Writeln (f2, '<meta name="generator" content="hlf to html ',ver,'">');
  Writeln (f2, '<TITLE>',ParamStr(1),'</TITLE>');
  Writeln (f2, '<style type="text/css">');
  Writeln (f2, '<!--');
  Writeln (f2, '.top1 { font-family: Tahoma, Arial, sans-serif; font-size: small;'
                + ' font-weight: bold; color: #000066}');
  Writeln (f2, '.center1 { text-align: left; font-weight: bold}');
  Writeln (f2, '.high1 { color: #000000; font-weight: bold}');
  Writeln (f2, 'pre { font-family: "Lucida Console", "Courier New", Courier;'
                + ' font-size: 13px; color: #000000}');
  Writeln (f2, 'body { background-color: #FFFFFF}');

  for j := 1 to 16 do       {  ᪮ ⠡ ⨫ }
  begin
    First := true;
    for i := 1 to 16 do
    if ColorArr [i,j] then
    begin
      if not First then
        Write (f2, ', ');
      First := false;
      Write (f2, '.c', ColorStr[j], ColorStr[i]);
    end;
    if not First then
      Writeln (f2, ' { background-color: ', ConvertColor(ColorStr[j]), '}');
  end;

  for j := 1 to 16 do
  begin
    First := true;
    for i := 1 to 16 do
    if ColorArr [j,i] then
    begin
      if not First
        then Write (f2, ', ')
        else First := false;
      Write (f2, '.c', ColorStr[i], ColorStr[j]);
    end;
    if not First then
      Writeln (f2, ' { color: ',ConvertColor(ColorStr[j]), '}');
  end;

  Writeln (f2, '-->');
  Writeln (f2, '</style>');
  Writeln (f2, '<LINK REL=stylesheet HREF="custom.css" TYPE="text/css">');
  Writeln (f2, '</HEAD>');
  Writeln (f2);
  Writeln (f2, '<BODY>');
  Writeln (f2, '<PRE>');
end;


{ "墮" 㬥}
procedure WriteBottom;
begin
  Writeln(f2,'</PRE>'); Writeln(f2,'</BODY>'); Writeln(f2,'</HTML>');
end;


{楤   宦 ப A  ப S  ப B}
{: ப B    ᥡ ᮤঠ ப A}
procedure ReplaceEx (var S: string; A,B : string);
var
  Z : integer;
begin
  Z := Pos(A, S);
  while Z > 0 do
  begin
    Delete (S, Z, Length(A));
    Insert (B, S, Z);
    Z := Pos(A, S);
  end;
end;


{ 㭪 । 㡫஢ ⥬ ᨬ }
function SysDoubleChar (a, b : char) : boolean;
const
  SSymbol = '~#@\';
var
  X : integer;
begin
  X := Pos (A, SSymbol);
  if (X <> 0) and (A = B)
    then SysDoubleChar := true
    else SysDoubleChar := false;
end;


{楤 ࠡ뢠  ப  頥   室 䠩.
 ࠡ뢠 ᢥ⪨  뫪}
var
  HCenter     : boolean;

procedure WriteLine (var S : string);
var
  High, Link  : boolean;
  i,j         : byte;
  LStr, LStr2 : string;
  Flag        : boolean;
  ColorChange : boolean;

begin       {WriteLine}
  ReplaceEx (S,'<','&lt;');
  ReplaceEx (S,'>','&gt;');
  ReplaceEx (S,'"','&quot;');

  ColorChange := false;
  If Length(S) = 0 then Exit;
  HCenter := false;
  If S[1]='^' then                        {஢}
  begin
    HCenter := true;
    Write(f2,'<span class="center1">');
    Delete(S,1,1);
  end;

  High := false; Link := false; LStr := '';
  i := 1;
  S := S + ' ';
  while i <= Length(S)-1 do
  begin
    if SysDoubleChar (S[i], S[i+1]) then
    begin
      Write(f2,S[i]);  {㦥 ᨬ ~#@,  㡫஢}
      i := i+1;
    end
    else
    case S[i] of                                     {  ᢥ⪨ }
      '#' : begin
              High := not High;
              if High
              then Write(f2,'<span class="high1">')
              else Write(f2,'</span>');
            end;
      '~' : begin                                    {  뫪 }
              j := 1; LStr := '';
              Flag := (S[i+j] = '~') and (S[i+j+1] <> '~') ;
              while not Flag do
              begin
                if SysDoubleChar (S[i+j], S[i+j+1])
                  then j := j + 1;
                LStr := LStr + S[i+j];
                j := j+1;
                Flag := (S[i+j] = '~') and (S[i+j+1] <> '~') ;
              end;

              LStr2 := '';
              i := i + j + 1;
              j := 1;

              Flag := (S[i+j] = '@') and (S[i+j+1] <> '@') ;
              while not Flag do
              begin
                if SysDoubleChar (S[i+j], S[i+j+1])
                  then j := j + 1;
                LStr2 := LStr2 + S[i+j];
                j:= j+1;
                Flag := (S[i+j] = '@') and (S[i+j+1] <> '@') ;
              end;
              Write (f2,'<a class="link1" href="');
              if (copy(Lstr2,1,5) <> 'file:')  and
                 (copy(Lstr2,1,5) <> 'ftp:/')  and
                 (copy(Lstr2,1,5) <> 'http:')  and
                 (copy(Lstr2,1,5) <> 'mailt')  and
                 (copy(Lstr2,1,5) <> 'news:')  and
                 (copy(Lstr2,1,5) <> 'telne')
                 then Write(f2,'#');
              Write (f2, Lstr2, '">',LStr,'</a>');
              i:= i+j;
            end;
      else                                         {case else}

      if ((S[i] = CtrlColorChar) and (S[i+1] = '-')) or
         ((S[i] = CtrlColorChar) and
         ((Pos(UpCase(S[i+1]),ColorStr) <> 0)  and
          (Pos(UpCase(S[i+2]),ColorStr) <> 0)))
      then                                         {  梥 }
      begin
        if ColorChange then Write (f2, '</span>');
        i := i + 1;
        if S[i] = '-'
          then ColorChange := false
          else
          begin
            ColorChange := true;
            Write (f2, '<span class=c',S[i],S[i+1],'>');
            i := i + 1;
         end;
      end
      else
        Write(f2,S[i]);
    end;
    i:=i+1;
  end;

  if HCenter then                          { ஥ ⥣ 業஢ }
    Write(f2,'</span>');
end;


{楤   䠩, 뢠 ࠭ ᠭ 楤}
procedure ConvertIt;
var
  St,StOld  : string;
  Z         : integer;
  FLine     : boolean;
begin
  WriteTop;
  St := '111';
  while (not Eof(f1)) and (St[1]<>'@')         { ࢮ ⥬ ...     }
        and not ((St[2] = '+') or (St[2] = '-')) do
  begin
    Readln (f1, St);
    if Pos('CtrlColorChar',St)<>0 then
    begin
      Z := Pos('=',St);
      CtrlColorChar := St[Z+1];
    end;

    if length(St) < 2 then St := '111';
  end;

  while not Eof(f1) do
  begin
    Delete (St,1,1);
    Write (f2,'<a name="',St,'">');            { 뢠 ਢ離 }
    St := '111';
    Readln(f1,St);
    Write (f2,'<span class="top1">');
    FLine := true;
    while (not Eof(f1)) and (St[1]='$') do     {   ⥬... }
    begin
      Delete(St,1,1);
      ReplaceEx(St,'#','');                    { 塞 ᢥ}

      while (Length(St)>0) and (St[1]=' ') do  { 塞 砫쭠 ஡ }
        Delete (St, 1, 1);
     if not FLine then Writeln(f2);
      WriteLine(St);                           {  ப }
      FLine := False;
      St:='111';
      Readln(f1,St);
    end;
    Writeln(f2,'</span>');                     {   }
    Writeln(f2);

    while (not Eof(f1)) and (Length(St)=0) do
      Readln (f1, St);

    while (not Eof(f1)) and ((St[1]<>'@')      {  ᮤন ⥬... }
          or (St[2] = '+') or (St[2] = '-')) do
    begin
      if (copy(St,1,2) <> '@+') and (copy(St,1,2) <> '@-')
      then begin
        Writeline(St);                         {  ப }
        WriteLn(f2);
      end;
        St:='111';
        Readln(f1,St);
    end;
  end;
  Writeline(St);                               {  ப   }
  WriteBottom;                                 {  "墮" }
end;


{ 㭪 頥 TRUE ᫨ 䠩 .  - FALSE }
function FileExists(FileName: String): Boolean;
var
  F: file;
begin
  {$I-} Assign(F, FileName); Reset(F); Close(F); {$I+}
  FileExists := (IOResult = 0) and (FileName <> '');
end;


{ ஢  ண 䠩   ࢮ }
procedure GenerateFileName (var Name1, Name2 : string);
var
  Z : integer;
begin
  Z := Length (Name1);
  while (Z > 0) and (Name1[Z] <> '.') do Z := Z - 1;
  if Z = 0 then
  begin
    Name2 := Name1 + '.htm';
    Name1 := Name1 + '.hlf';
  end
  else begin
    Z := Z - 1;
    Name2 := Copy (Name1, 1, Z) + '.htm';
  end;
end;


{ 楤 ⢫  室  䠩  ᪮ ᬥ 梥⮢
   ᮡࠥ  ଠ  ࠭ ᪨ ᮧ
  ⠡ ⨫ }
procedure GetColorInfo;
var
  S    : string;
  Z,i  : integer;
  X, Y : integer;
begin
  while not Eof (f1) do
  begin
    Readln (f1, S);
    if (CtrlColorChar=#0) and (Pos('CtrlColorChar',S)<>0) then
    begin
      Z := Pos('=',S);
      CtrlColorChar := S[Z+1];
    end;

    for i := 1 to Length (S)-2 do
      if (S[i] = CtrlColorChar) and (S[i+1] <> '-') then
      begin
        X := Pos (Upcase(S[i+2]), ColorStr);
        Y := Pos (UpCase(S[i+1]), ColorStr);
        if (X > 0) and (Y > 0) then
          ColorArr [X,Y] := true;
      end;
  end;
  Reset (f1);
end;


{ ᭮ 楤 }
procedure Main;
var
  Name1, Name2 : string;
  Z : integer;
  C : string[10];
begin
  FillChar (ColorArr, Sizeof(tArr), 0);

  if ParamCount = 0 then
  begin
    ShowHelp;
    Exit;
  end;

  Name1 := ParamStr(1);
  if ParamCount > 1
    then Name2 := ParamStr(2)
    else GenerateFileName (Name1, Name2);

  Assign (f1, Name1);
  {$I-}
    Reset (f1);
  {$I+}
  if IOResult <> 0 then
  begin
    Writeln (' : ',Name1,'  !');
    Exit;
  end;

  while FileExists(Name2) do
  begin
    repeat
      Write ('।०.  "',Name2,'" 㦥 ! १? (y/n) ');
      Readln (C);
    until (C='Y') or (C='y') or (C='N') or (C='n');
    if (C='N') or (C='n') then
    begin
      Write (' 㣮  䠩: ');
      Readln (Name2);
    end
    else begin
      Assign (f2, Name2);
      Erase (f2);
    end;
  end;
  {$I+}
  Assign (f2, Name2);
  Rewrite (f2);

  New (Buf);
  SetTextBuf (F2, Buf^);

  GetColorInfo;
  ConvertIt;

  Close (f1);
  Close (f2);

  Dispose (Buf);
  Writeln('஢ 䠩: ',Name1,' 襭. ᠭ 䠩: ',Name2);
end;

begin
  Main;
end.
